#include <stdio.h>
#include <stdlib.h>

static int factorial(int n)
  { if (n > 1)
      return n * factorial(n - 1);
    else
      return 1; }

typedef
  struct cl * clos;
             
typedef
   void (* cont)(int, clos);
  
typedef
  struct cl { int n;
              cont continuation;
              clos closure; } cl;

static clos make_closure(int n, cont continuation, clos closure)
  { clos new_closure = malloc(sizeof(cl));
    new_closure->n = n;
    new_closure->continuation = continuation;
    new_closure->closure = closure;
    return new_closure; }
    
static void continuation(int p, clos closure)
  { cont continuation = closure->continuation;
    int n = closure->n;
    clos nested_closure = closure->closure;
    free(closure);
    continuation(n * p, nested_closure); }
           
static void c_factorial(clos closure)
  { int n = closure->n;
    cont nested_continuation = closure->continuation;
    clos nested_closure = closure->closure;
    if (n > 1)
      c_factorial(make_closure(n - 1, continuation, closure));
    else
      nested_continuation(1, nested_closure); }

static void top_continuation(int p, clos closure)
  { printf("c_factorial(10) = %d\n", p); }

int main (int argc, const char * argv[])
  { printf("factorial(10)   = %d\n", factorial(10));
    c_factorial(make_closure(10, top_continuation, (clos)0));
    return 0; }
